//by goingnuts  090111 for pupngo
// org blinky bin 39K
// org blinky libs demand 8854K
// pmnet 24K
// pmnet libs demand 1940K


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/extensions/shape.h>
#include "idle.xpm"
#include "txrx.xpm"
#include "rx.xpm"
#include "tx.xpm"

#define MAX_MOUSE_REGION (12)
typedef struct {		//Mouse Regions
    int     enable;
    int     top;
    int     bottom;
    int     left;
    int     right;
} MOUSE_REGION;

MOUSE_REGION    mouse_region[MAX_MOUSE_REGION];

#define APPNAME "pmnet"
#define DELAY 1 //seconds
#define BUFFER_SIZE 512

int     refresh = 100000;
int     kill = 1;
int     DOWN = 0;
int     UP = 0;
int     DOWN_OLD = 0;
int     UP_OLD = 0;
char    leftcommand[BUFFER_SIZE - 1] = "";
char    midcommand[BUFFER_SIZE - 1] = "";
char    rightcommand[BUFFER_SIZE - 1] = "";
char    device[BUFFER_SIZE - 1] = "eth0";
char    bgcolour[BUFFER_SIZE - 1] = "black";

static void button_down(int w, int x, int y);
void        AddMouseRegion(int index, int left, int top, int right, int bottom);
int         CheckMouseRegion(int x, int y);
void        EnableMouseRegion(int index);
void        DisableMouseRegion(int index);
void        dockapp_setshape(Pixmap mask, int x_ofs, int y_ofs);


int main(int argc, char** argv) {
	
  int           num, i, screen_num;
  int           delay = DELAY;
  char          *displayName = NULL;
  char          buf[32];
  char          myCommand[256];
  unsigned long background;
  int           update = delay * 1000000;
  int           count = update;	
  FILE          *fp;
  XEvent        Event;
  Display*      display;
  Pixmap image;
  Colormap cmap;
  XColor xc, xc2;
  
  // Parse command line
  for(i=1; i <argc; i++) {
     if (!strcmp(argv[i], "-b") && (argc > i+1)) {
    	 strcpy (bgcolour, argv[++i]);
    	 bgcolour[BUFFER_SIZE - 1] = '\0'; 
     } else if (!strcmp(argv[i], "-d") && (argc > i+1)) {
         displayName = argv[++i];
	 } else if (!strcmp(argv[i], "-k") && (argc > i+1)) {
    	 kill = atoi(argv[++i]);
     } else if (!strcmp(argv[i], "-l") && (argc > i+1)) {
    	 strcpy (leftcommand, argv[++i]);
    	 leftcommand[BUFFER_SIZE - 1] = '\0';
     } else if (!strcmp(argv[i], "-m") && (argc > i+1)) {
    	 strcpy (midcommand, argv[++i]);
    	 midcommand[BUFFER_SIZE - 1] = '\0';    	 
     } else if (!strcmp(argv[i], "-n") && (argc > i+1)) {
    	 strcpy (device, argv[++i]);
    	 device[BUFFER_SIZE - 1] = '\0'; 
     } else if (!strcmp(argv[i], "-r") && (argc > i+1)) {
    	 strcpy (rightcommand, argv[++i]);
    	 rightcommand[BUFFER_SIZE - 1] = '\0';
     } else if (!strcmp(argv[i], "-u") && (argc > i+1)) {
         delay = atoi(argv[++i]);
     } else {
         if (!(!strcmp(argv[i], "-h") || !strcmp(argv[i], "--help"))) {
            printf("%s: bad option or missing argument.\n",argv[i]);
            return 0;
         }
         printf("%s by GoingNuts.dk\n"
         "options:\n"
         "-b \"bgcolour\"   Window bg colour, ex. \"LightGray\"\n"
         "-d <disp>      Set the display\n"
         "-k <kill>      Kill other running %s - 1=yes/0=no, default 1\n"
         "-l \"command\"   Command to execute on left button mousekey press\n"
         "-m \"command\"   Command to execute on left button mousekey press\n"
         "-n <device>    Net device (default eth0)\n"
         "-r \"command\"   Command to execute on left button mousekey press\n"
         "-n <device>    Net device (default eth0)\n"
         "-u <seconds>   Set update interval (default 0.5)\n"
         "-h, --help     Display this help text and exit\n", APPNAME, APPNAME );
         return 0;
     }
  }
  
  // Kill other running
  if ( kill == 1 ) {
     system("kill $(pidof pmnet | grep ' ' | cut -f 2 -d ' ')");
  }
  
  // Open display
  if ((display = XOpenDisplay(displayName)) == NULL) {
    printf("%s could not open display %s\n", APPNAME, displayName);
    return 0;
  }
	 
  // Colours background
  screen_num = DefaultScreen(display);
  cmap = DefaultColormap(display, screen_num);
  XAllocNamedColor(display, cmap, bgcolour, &xc, &xc2);
  background = xc.pixel;
  
  // Create windows
  Window root    = RootWindow(display, DefaultScreen(display));
  Window appWin  = XCreateSimpleWindow(display, root,   0,0,26,24,0,0,background);
  Window iconWin = XCreateSimpleWindow(display, appWin, 2,3,22,20,0,0,0);
        
  // Set classhint
  XClassHint classHint;
  classHint.res_name  = APPNAME;
  classHint.res_class = APPNAME;
  XSetClassHint(display, appWin, &classHint);

  // Set windowname
  XStoreName(display, appWin, APPNAME);
  XSetIconName(display, appWin, APPNAME);

  // Set command
  XSetCommand(display, appWin, argv, argc);
  
  XMapWindow(display, appWin);
  XMapWindow(display, iconWin);
  
  // Main loop
  while(1) {
  	
  	// Check if time to update
   if (count >= update) {
      count = 0;
  	
  	snprintf(myCommand,256,"cat /proc/net/dev | grep \"%s\" | sed 's/  */ /g' | cut -d ' ' -f 3",device);
  	fp=(FILE*)popen(myCommand,"r");
  	fgets(buf, 32, fp);
	DOWN = atoi(buf);
	fclose(fp);
	
	snprintf(myCommand,256,"cat /proc/net/dev | grep \"%s\" | sed 's/  */ /g' | cut -d ' ' -f 11",device);
	fp=(FILE*)popen(myCommand,"r");
	fgets(buf, 32, fp);
	UP = atoi(buf);
	fclose(fp);
	
	XpmAttributes attrib;
	attrib.valuemask = 0;

	if (DOWN_OLD == DOWN) {
        if (UP_OLD < UP) {
        num = XpmCreatePixmapFromData(display,appWin,tx_xpm,&image,NULL,&attrib);
    } else
       	num = XpmCreatePixmapFromData(display,appWin,idle_xpm,&image,NULL,NULL);
    } else if (DOWN_OLD < DOWN) {
    	if (UP_OLD < UP) {
    	num = XpmCreatePixmapFromData(display,appWin,txrx_xpm,&image,NULL,NULL);
    } else
	   	num = XpmCreatePixmapFromData(display,appWin,rx_xpm,&image,NULL,NULL);
    }
    
    DOWN_OLD=DOWN;
    UP_OLD=UP;

    // Tell the display server what kind of events we would like to see
	XSelectInput(display, appWin, ButtonPressMask|DestroyNotify);
    XSetWindowBackgroundPixmap(display, iconWin, image);
        
    XClearWindow(display, iconWin);
    XFreePixmap(display, image);
    XSync(display, False);
        
    }		// end update icon
    
    while (XPending(display)) {
			XNextEvent(display, &Event);
			switch (Event.type) {
			case DestroyNotify:
				XCloseDisplay(display);
				exit(0);
				break;
			case ButtonPress:
			button_down(Event.xbutton.button,Event.xbutton.x, Event.xbutton.y);
			//    system(command);
				break;
			}
		}

    usleep(refresh);
    count = count + refresh;
  }

  return 0;
}

static void button_down(int w,int x, int y) {

int z;

z = CheckMouseRegion(x, y);
printf("w,x,y,z is %i,%i,%i, %i \n", w,x,y,z);
if(w == 1) {
printf("left button pressed\n");
 system(leftcommand);
}
if(w == 2) {
printf("middle button pressed\n");
 system(midcommand);
}
if(w == 3) {
printf("right button pressed\n");
 system(rightcommand);
}

}


// CheckMouseRegion
int CheckMouseRegion(int x, int y) {
    int     i;
    int     found;

    found = 0;

    for (i=0; i<MAX_MOUSE_REGION && !found; i++) {
        if (mouse_region[i].enable==1 &&
            x <= mouse_region[i].right &&
            x >= mouse_region[i].left &&
            y <= mouse_region[i].bottom &&
            y >= mouse_region[i].top)
            found = 1;
    }
    if (!found) return -1;
    return (i-1);
}

//  EnableMouseRegion
void EnableMouseRegion(int i) {
    if(i<MAX_MOUSE_REGION && mouse_region[i].enable==2)
        mouse_region[i].enable=1;
}

// DisableMouseRegion
void DisableMouseRegion(int i) {
    if(i<MAX_MOUSE_REGION && mouse_region[i].enable==1)
        mouse_region[i].enable=2;
}

